blob: e7b85382d09aa08414ca80148bde0df8533786b5 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Dan Willemsen838dcec2021-09-30 22:40:34 +0000243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000255 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
257
258 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
259 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
260 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200261
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800262 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
263 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
264
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200265 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
266 # to ensure that the corresponding 'emulator' binaries are used.
267 case $(uname -s) in
268 Darwin)
269 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
270 ;;
271 Linux)
272 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
273 ;;
274 *)
275 ANDROID_EMULATOR_PREBUILTS=
276 ;;
277 esac
278 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700279 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200280 export ANDROID_EMULATOR_PREBUILTS
281 fi
282
Jim Tangb3fda302018-12-22 10:24:55 +0800283 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
284 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700285 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
286 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
287 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000288 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800289
Martin Stjernholm6a012262021-11-24 14:56:15 +0000290 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700291 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800292
293 # out with the duplicate old
294 if [ -n $ANDROID_PYTHONPATH ]; then
295 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
296 fi
297 # and in with the new
298 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800299 if [ -n $VENDOR_PYTHONPATH ]; then
300 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
301 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800302 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800303
Colin Crosse97e6932017-06-30 16:01:45 -0700304 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
305 export JAVA_HOME=$ANDROID_JAVA_HOME
306 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
307 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
308 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500309
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800310 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700311 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
312 export OUT=$ANDROID_PRODUCT_OUT
313
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700314 unset ANDROID_HOST_OUT
315 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
316
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900317 unset ANDROID_SOONG_HOST_OUT
318 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
319
Simran Basidd050ed2017-02-13 13:46:48 -0800320 unset ANDROID_HOST_OUT_TESTCASES
321 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
322
323 unset ANDROID_TARGET_OUT_TESTCASES
324 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
325
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800326 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700327 # TODO: fix the path
328 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
329}
330
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000331function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000332{
Jingwen Chen17d56992021-06-10 08:17:54 +0000333 if which bazel &>/dev/null; then
334 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
335 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000336 fi
337
Jingwen Chen17d56992021-06-10 08:17:54 +0000338 local T="$(gettop)"
339 if [ ! "$T" ]; then
340 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
341 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000342 fi
343
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000344 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000345}
346
Matt Alexanderd9c56562020-05-21 10:49:17 +0000347function printconfig()
348{
Christopher Ferris55257d22017-03-23 11:08:58 -0700349 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800350 if [ ! "$T" ]; then
351 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
352 return
353 fi
354 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700355}
356
Matt Alexanderd9c56562020-05-21 10:49:17 +0000357function set_stuff_for_environment()
358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800359 setpaths
360 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700361
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800362 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700363 # With this environment variable new GCC can apply colors to warnings/errors
364 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700365}
366
Matt Alexanderd9c56562020-05-21 10:49:17 +0000367function set_sequence_number()
368{
Colin Cross88737132017-03-21 17:41:03 -0700369 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700370}
371
Makoto Onukida971062018-06-18 10:15:19 -0700372# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
373function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800374 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700375 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800376 *:"$cmd":*)
377 return 1
378 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700379 esac
380 return 0
381}
382
Matt Alexanderd9c56562020-05-21 10:49:17 +0000383function addcompletions()
384{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700385 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700386
Jim Tanga881a252018-06-19 16:34:41 +0800387 # Keep us from trying to run in something that's neither bash nor zsh.
388 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700389 return
390 fi
391
392 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800393 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700394 return
395 fi
396
Jim Tanga881a252018-06-19 16:34:41 +0800397 local completion_files=(
398 system/core/adb/adb.bash
399 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800400 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800401 )
Makoto Onukida971062018-06-18 10:15:19 -0700402 # Completion can be disabled selectively to allow users to use non-standard completion.
403 # e.g.
404 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
405 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800406 for f in ${completion_files[*]}; do
407 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700408 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700409 fi
410 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700411
Matt Alexanderd9c56562020-05-21 10:49:17 +0000412 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700413 complete -C "bit --tab" bit
414 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000415 if [ -z "$ZSH_VERSION" ]; then
416 # Doesn't work in zsh.
417 complete -o nospace -F _croot croot
418 fi
Jim Tanga881a252018-06-19 16:34:41 +0800419 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800420
Cole Faust24c36db2021-01-23 02:39:37 +0000421 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100422 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000423 complete -F _complete_android_module_names outmod
424 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100425 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700426}
427
Joe Onorato824608c2022-04-08 11:06:16 -0700428function multitree_lunch_help()
429{
430 echo "usage: lunch PRODUCT-VARIANT" 1>&2
431 echo " Set up android build environment based on a product short name and variant" 1>&2
432 echo 1>&2
433 echo "lunch COMBO_FILE VARIANT" 1>&2
434 echo " Set up android build environment based on a specific lunch combo file" 1>&2
435 echo " and variant." 1>&2
436 echo 1>&2
437 echo "lunch --print [CONFIG]" 1>&2
438 echo " Print the contents of a configuration. If CONFIG is supplied, that config" 1>&2
439 echo " will be flattened and printed. If CONFIG is not supplied, the currently" 1>&2
440 echo " selected config will be printed. Returns 0 on success or nonzero on error." 1>&2
441 echo 1>&2
442 echo "lunch --list" 1>&2
443 echo " List all possible combo files available in the current tree" 1>&2
444 echo 1>&2
445 echo "lunch --help" 1>&2
446 echo "lunch -h" 1>&2
447 echo " Prints this message." 1>&2
448}
449
450function multitree_lunch()
451{
452 local code
453 local results
454 if $(echo "$1" | grep -q '^-') ; then
455 # Calls starting with a -- argument are passed directly and the function
456 # returns with the lunch.py exit code.
457 build/make/orchestrator/core/lunch.py "$@"
458 code=$?
459 if [[ $code -eq 2 ]] ; then
460 echo 1>&2
461 multitree_lunch_help
462 return $code
463 elif [[ $code -ne 0 ]] ; then
464 return $code
465 fi
466 else
467 # All other calls go through the --lunch variant of lunch.py
468 results=($(build/make/orchestrator/core/lunch.py --lunch "$@"))
469 code=$?
470 if [[ $code -eq 2 ]] ; then
471 echo 1>&2
472 multitree_lunch_help
473 return $code
474 elif [[ $code -ne 0 ]] ; then
475 return $code
476 fi
477
478 export TARGET_BUILD_COMBO=${results[0]}
479 export TARGET_BUILD_VARIANT=${results[1]}
480 fi
481}
482
Matt Alexanderd9c56562020-05-21 10:49:17 +0000483function choosetype()
484{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700485 echo "Build type choices are:"
486 echo " 1. release"
487 echo " 2. debug"
488 echo
489
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800490 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700491 DEFAULT_NUM=1
492 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700493
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800494 export TARGET_BUILD_TYPE=
495 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700496 while [ -z $TARGET_BUILD_TYPE ]
497 do
498 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000499 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800500 read ANSWER
501 else
502 echo $1
503 ANSWER=$1
504 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700505 case $ANSWER in
506 "")
507 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
508 ;;
509 1)
510 export TARGET_BUILD_TYPE=release
511 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800512 release)
513 export TARGET_BUILD_TYPE=release
514 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700515 2)
516 export TARGET_BUILD_TYPE=debug
517 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800518 debug)
519 export TARGET_BUILD_TYPE=debug
520 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700521 *)
522 echo
523 echo "I didn't understand your response. Please try again."
524 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700525 ;;
526 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000527 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800528 break
529 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700530 done
531
Ying Wang08800fd2016-03-03 20:57:21 -0800532 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700533 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800534 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700535}
536
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800537#
538# This function isn't really right: It chooses a TARGET_PRODUCT
539# based on the list of boards. Usually, that gets you something
540# that kinda works with a generic product, but really, you should
541# pick a product by name.
542#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000543function chooseproduct()
544{
Christopher Ferris55257d22017-03-23 11:08:58 -0700545 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000546 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700547 default_value=$TARGET_PRODUCT
548 else
Ying Wang0a76df52015-06-08 11:57:26 -0700549 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700550 fi
551
Ying Wang08800fd2016-03-03 20:57:21 -0800552 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800553 export TARGET_PRODUCT=
554 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700555 while [ -z "$TARGET_PRODUCT" ]
556 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700557 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000558 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800559 read ANSWER
560 else
561 echo $1
562 ANSWER=$1
563 fi
564
Matt Alexanderd9c56562020-05-21 10:49:17 +0000565 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700566 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800567 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000568 if check_product $ANSWER
569 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800570 export TARGET_PRODUCT=$ANSWER
571 else
572 echo "** Not a valid product: $ANSWER"
573 fi
574 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000575 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800576 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700577 fi
578 done
579
Ying Wang08800fd2016-03-03 20:57:21 -0800580 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700581 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800582 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700583}
584
Matt Alexanderd9c56562020-05-21 10:49:17 +0000585function choosevariant()
586{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800587 echo "Variant choices are:"
588 local index=1
589 local v
590 for v in ${VARIANT_CHOICES[@]}
591 do
592 # The product name is the name of the directory containing
593 # the makefile we found, above.
594 echo " $index. $v"
595 index=$(($index+1))
596 done
597
598 local default_value=eng
599 local ANSWER
600
601 export TARGET_BUILD_VARIANT=
602 while [ -z "$TARGET_BUILD_VARIANT" ]
603 do
604 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000605 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800606 read ANSWER
607 else
608 echo $1
609 ANSWER=$1
610 fi
611
Matt Alexanderd9c56562020-05-21 10:49:17 +0000612 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800613 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000614 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
615 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200616 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800617 fi
618 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000619 if check_variant $ANSWER
620 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800621 export TARGET_BUILD_VARIANT=$ANSWER
622 else
623 echo "** Not a valid variant: $ANSWER"
624 fi
625 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000626 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800627 break
628 fi
629 done
630}
631
Matt Alexanderd9c56562020-05-21 10:49:17 +0000632function choosecombo()
633{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700634 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700635
636 echo
637 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700638 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700639
640 echo
641 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700642 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800643
644 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800645 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700646 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800647 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800648 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700649}
650
Matt Alexanderd9c56562020-05-21 10:49:17 +0000651function add_lunch_combo()
652{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800653 if [ -n "$ZSH_VERSION" ]; then
654 echo -n "${funcfiletrace[1]}: "
655 else
656 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
657 fi
658 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800659}
660
Matt Alexanderd9c56562020-05-21 10:49:17 +0000661function print_lunch_menu()
662{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700663 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100664 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700665 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100666 local ret=$?
667
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700668 echo
669 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700670 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100671
Matt Alexanderd9c56562020-05-21 10:49:17 +0000672 if [ $ret -ne 0 ]
673 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100674 echo "Warning: Cannot display lunch menu."
675 echo
676 echo "Note: You can invoke lunch with an explicit target:"
677 echo
678 echo " usage: lunch [target]" >&2
679 echo
680 return
681 fi
682
Will Burr40401202022-02-07 12:12:01 +0000683 echo "Lunch menu .. Here are the common combinations:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800684
685 local i=1
686 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700687 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800688 do
689 echo " $i. $choice"
690 i=$(($i+1))
691 done
692
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700693 echo
694}
695
Matt Alexanderd9c56562020-05-21 10:49:17 +0000696function lunch()
697{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800698 local answer
699
Steven Moreland92793dc2020-02-25 18:30:18 -0800700 if [[ $# -gt 1 ]]; then
701 echo "usage: lunch [target]" >&2
702 return 1
703 fi
704
Will Burr40401202022-02-07 12:12:01 +0000705 local used_lunch_menu=0
706
Steven Moreland92793dc2020-02-25 18:30:18 -0800707 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800708 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700709 else
710 print_lunch_menu
Will Burr40401202022-02-07 12:12:01 +0000711 echo "Which would you like? [aosp_arm-eng]"
712 echo -n "Pick from common choices above (e.g. 13) or specify your own (e.g. aosp_barbet-eng): "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800713 read answer
Will Burr40401202022-02-07 12:12:01 +0000714 used_lunch_menu=1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700715 fi
716
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800717 local selection=
718
Matt Alexanderd9c56562020-05-21 10:49:17 +0000719 if [ -z "$answer" ]
720 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700721 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000722 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
723 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800724 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000725 if [ $answer -le ${#choices[@]} ]
726 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800727 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000728 if [ -n "$ZSH_VERSION" ]
729 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800730 selection=${choices[$(($answer))]}
731 else
732 selection=${choices[$(($answer-1))]}
733 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800734 fi
Colin Cross88737132017-03-21 17:41:03 -0700735 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800736 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700737 fi
738
Joe Onoratoda12daf2010-06-09 18:18:31 -0700739 export TARGET_BUILD_APPS=
740
Colin Cross88737132017-03-21 17:41:03 -0700741 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700742 product=${selection%%-*} # Trim everything after first dash
743 variant_and_version=${selection#*-} # Trim everything up to first dash
744 if [ "$variant_and_version" != "$selection" ]; then
745 variant=${variant_and_version%%-*}
746 if [ "$variant" != "$variant_and_version" ]; then
747 version=${variant_and_version#*-}
748 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700749 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800750
Matt Alexanderd9c56562020-05-21 10:49:17 +0000751 if [ -z "$product" ]
752 then
Ying Wang08800fd2016-03-03 20:57:21 -0800753 echo
Colin Cross88737132017-03-21 17:41:03 -0700754 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700755 return 1
756 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800757
Colin Cross88737132017-03-21 17:41:03 -0700758 TARGET_PRODUCT=$product \
759 TARGET_BUILD_VARIANT=$variant \
760 TARGET_PLATFORM_VERSION=$version \
761 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000762 if [ $? -ne 0 ]
763 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100764 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
765 then
766 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
767 fi
Colin Cross88737132017-03-21 17:41:03 -0700768 return 1
769 fi
Colin Cross88737132017-03-21 17:41:03 -0700770 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
771 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700772 if [ -n "$version" ]; then
773 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
774 else
775 unset TARGET_PLATFORM_VERSION
776 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700777 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700778
Will Burr40401202022-02-07 12:12:01 +0000779 if [ $used_lunch_menu -eq 1 ]; then
780 echo
781 echo "Hint: next time you can simply run 'lunch $selection'"
782 fi
783
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700784 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800785
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700786 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700787 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800788 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700789}
790
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700791unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700792# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000793function _lunch()
794{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700795 local cur prev opts
796 COMPREPLY=()
797 cur="${COMP_WORDS[COMP_CWORD]}"
798 prev="${COMP_WORDS[COMP_CWORD-1]}"
799
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700800 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800801 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700802 fi
803
804 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700805 return 0
806}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700807
Joe Onoratoda12daf2010-06-09 18:18:31 -0700808# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700809# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000810function tapas()
811{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700812 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800813 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700814 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700815 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800816 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Joe Onoratoda12daf2010-06-09 18:18:31 -0700817
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700818 if [ "$showHelp" != "" ]; then
819 $(gettop)/build/make/tapasHelp.sh
820 return
821 fi
822
Ying Wang67f02922012-08-22 10:25:20 -0700823 if [ $(echo $arch | wc -w) -gt 1 ]; then
824 echo "tapas: Error: Multiple build archs supplied: $arch"
825 return
826 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700827 if [ $(echo $variant | wc -w) -gt 1 ]; then
828 echo "tapas: Error: Multiple build variants supplied: $variant"
829 return
830 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700831 if [ $(echo $density | wc -w) -gt 1 ]; then
832 echo "tapas: Error: Multiple densities supplied: $density"
833 return
834 fi
Ying Wang67f02922012-08-22 10:25:20 -0700835
Ying Wang0a76df52015-06-08 11:57:26 -0700836 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700837 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000838 x86) product=aosp_x86;;
839 arm64) product=aosp_arm64;;
840 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700841 esac
Joe Onoratoda12daf2010-06-09 18:18:31 -0700842 if [ -z "$variant" ]; then
843 variant=eng
844 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700845 if [ -z "$apps" ]; then
846 apps=all
847 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600848 if [ -z "$density" ]; then
849 density=alldpi
850 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700851
Ying Wang67f02922012-08-22 10:25:20 -0700852 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700853 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700854 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700855 export TARGET_BUILD_TYPE=release
856 export TARGET_BUILD_APPS=$apps
857
Ying Wang08800fd2016-03-03 20:57:21 -0800858 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700859 set_stuff_for_environment
860 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800861 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700862}
863
Martin Stjernholmf692c752021-04-12 00:01:10 +0100864# Configures the build to build unbundled Android modules (APEXes).
865# Run banchan with one or more module names (from apex{} modules).
866function banchan()
867{
868 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100869 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100870 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100871 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100872
873 if [ "$showHelp" != "" ]; then
874 $(gettop)/build/make/banchanHelp.sh
875 return
876 fi
877
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100878 if [ -z "$product" ]; then
879 product=arm
880 elif [ $(echo $product | wc -w) -gt 1 ]; then
881 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100882 return
883 fi
884 if [ $(echo $variant | wc -w) -gt 1 ]; then
885 echo "banchan: Error: Multiple build variants supplied: $variant"
886 return
887 fi
888 if [ -z "$apps" ]; then
889 echo "banchan: Error: No modules supplied"
890 return
891 fi
892
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100893 case $product in
894 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100895 x86) product=module_x86;;
896 arm64) product=module_arm64;;
897 x86_64) product=module_x86_64;;
898 esac
899 if [ -z "$variant" ]; then
900 variant=eng
901 fi
902
903 export TARGET_PRODUCT=$product
904 export TARGET_BUILD_VARIANT=$variant
905 export TARGET_BUILD_DENSITY=alldpi
906 export TARGET_BUILD_TYPE=release
907
908 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
909 # case is different and it may diverge in the future.
910 export TARGET_BUILD_APPS=$apps
911
912 build_build_var_cache
913 set_stuff_for_environment
914 printconfig
915 destroy_build_var_cache
916}
917
Matt Alexanderd9c56562020-05-21 10:49:17 +0000918function gettop
919{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700920 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000921 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700922 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000923 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700924 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000925 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800926 # The following circumlocution (repeated below as well) ensures
927 # that we record the true directory name and not one that is
928 # faked up with symlink names.
929 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700930 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800931 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700932 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000933 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800934 \cd ..
synergyb112a402013-07-05 19:47:47 -0700935 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700936 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000937 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700938 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000939 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700940 fi
941 fi
942 fi
943}
944
Matt Alexanderd9c56562020-05-21 10:49:17 +0000945function croot()
946{
Christopher Ferris55257d22017-03-23 11:08:58 -0700947 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700948 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700949 if [ "$1" ]; then
950 \cd $(gettop)/$1
951 else
952 \cd $(gettop)
953 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700954 else
955 echo "Couldn't locate the top of the tree. Try setting TOP."
956 fi
957}
958
Matt Alexanderd9c56562020-05-21 10:49:17 +0000959function _croot()
960{
Anton Hanssonece9c482019-02-04 18:15:39 +0000961 local T=$(gettop)
962 if [ "$T" ]; then
963 local cur="${COMP_WORDS[COMP_CWORD]}"
964 k=0
965 for c in $(compgen -d ${T}/${cur}); do
966 COMPREPLY[k++]=${c#${T}/}/
967 done
968 fi
969}
970
Matt Alexanderd9c56562020-05-21 10:49:17 +0000971function cproj()
972{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700973 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700974 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700975 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700976 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
977 T=$PWD
978 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800979 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700980 return
981 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800982 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700983 done
Ying Wang9cd17642012-12-13 10:52:07 -0800984 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700985 echo "can't find Android.mk"
986}
987
Daniel Sandler47e0a882013-07-30 13:23:52 -0400988# simplified version of ps; output in the form
989# <pid> <procname>
990function qpid() {
991 local prepend=''
992 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000993 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400994 prepend=' '
995 append='$'
996 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000997 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800998 echo "usage: qpid [[--exact] <process name|pid>"
999 return 255
1000 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001001
1002 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001003 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -08001004 qpid | \grep "$prepend$EXE$append"
1005 else
1006 adb shell ps \
1007 | tr -d '\r' \
1008 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
1009 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -04001010}
1011
Steven Moreland74114f12020-09-10 01:23:32 +00001012# syswrite - disable verity, reboot if needed, and remount image
1013#
1014# Easy way to make system.img/etc writable
1015function syswrite() {
1016 adb wait-for-device && adb root || return 1
1017 if [[ $(adb disable-verity | grep "reboot") ]]; then
1018 echo "rebooting"
1019 adb reboot && adb wait-for-device && adb root || return 1
1020 fi
1021 adb wait-for-device && adb remount || return 1
1022}
1023
Iliyan Malcheve675cfb2014-11-03 17:04:47 -08001024# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001025# that has the core-file-size limit set correctly
1026#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001027# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001028# if its core-file-size limit is not set already.
1029# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
1030
Matt Alexanderd9c56562020-05-21 10:49:17 +00001031function coredump_setup()
1032{
1033 echo "Getting root...";
1034 adb root;
1035 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001036
Matt Alexanderd9c56562020-05-21 10:49:17 +00001037 echo "Remounting root partition read-write...";
1038 adb shell mount -w -o remount -t rootfs rootfs;
1039 sleep 1;
1040 adb wait-for-device;
1041 adb shell mkdir -p /cores;
1042 adb shell mount -t tmpfs tmpfs /cores;
1043 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001044
Matt Alexanderd9c56562020-05-21 10:49:17 +00001045 echo "Granting SELinux permission to dump in /cores...";
1046 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001047
Matt Alexanderd9c56562020-05-21 10:49:17 +00001048 echo "Set core pattern.";
1049 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001050
Ying Wang08800fd2016-03-03 20:57:21 -08001051 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001052}
1053
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001054# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001055# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001056#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001057# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001058# dump to actually be generated.
1059
Matt Alexanderd9c56562020-05-21 10:49:17 +00001060function coredump_enable()
1061{
1062 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001063 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001064 printf "Expecting a PID!\n";
1065 return;
1066 fi;
1067 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001068 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001069}
1070
1071# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001072# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001073#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001074# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001075# enabled globally.
1076
Matt Alexanderd9c56562020-05-21 10:49:17 +00001077function core()
1078{
1079 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001080
Ying Wang08800fd2016-03-03 20:57:21 -08001081 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001082 printf "Expecting a PID!\n";
1083 return;
1084 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001085
Matt Alexanderd9c56562020-05-21 10:49:17 +00001086 local CORENAME=core.$PID;
1087 local COREPATH=/cores/$CORENAME;
1088 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001089
Matt Alexanderd9c56562020-05-21 10:49:17 +00001090 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001091
Matt Alexanderd9c56562020-05-21 10:49:17 +00001092 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001093 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001094 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1095 adb shell kill -$SIG $PID;
1096 sleep 1;
1097 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001098
Matt Alexanderd9c56562020-05-21 10:49:17 +00001099 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1100 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001101}
1102
Christopher Tate744ee802009-11-12 15:33:08 -08001103# systemstack - dump the current stack trace of all threads in the system process
1104# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001105function systemstack()
1106{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001107 stacks system_server
1108}
1109
Michael Wrightaeed7212014-06-19 19:58:12 -07001110# Read the ELF header from /proc/$PID/exe to determine if the process is
1111# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001112function is64bit()
1113{
Ben Chengfba67bf2014-02-25 10:27:07 -08001114 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001115 if [ "$PID" ] ; then
1116 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001117 echo "64"
1118 else
1119 echo ""
1120 fi
1121 else
1122 echo ""
1123 fi
1124}
1125
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001126case `uname -s` in
1127 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001128 function sgrep()
1129 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001130 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001131 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001132 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001133
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001134 ;;
1135 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001136 function sgrep()
1137 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001138 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001139 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001140 }
1141 ;;
1142esac
1143
Matt Alexanderd9c56562020-05-21 10:49:17 +00001144function gettargetarch
1145{
Raghu Gandham8da43102012-07-25 19:57:22 -07001146 get_build_var TARGET_ARCH
1147}
1148
Matt Alexanderd9c56562020-05-21 10:49:17 +00001149function ggrep()
1150{
Mike Frysinger5e479732015-09-22 18:13:48 -04001151 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1152 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001153}
1154
Matt Alexanderd9c56562020-05-21 10:49:17 +00001155function gogrep()
1156{
Orion Hodson831472d2019-10-25 11:35:15 +01001157 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1158 -exec grep --color -n "$@" {} +
1159}
1160
Matt Alexanderd9c56562020-05-21 10:49:17 +00001161function jgrep()
1162{
Mike Frysinger5e479732015-09-22 18:13:48 -04001163 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1164 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001165}
1166
Alistair Delva176e5342021-02-22 13:31:26 -08001167function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001168{
1169 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1170 -exec grep --color -n "$@" {} +
1171}
1172
Taesu Leeea0cecd2020-10-28 11:05:18 +09001173function ktgrep()
1174{
1175 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1176 -exec grep --color -n "$@" {} +
1177}
1178
Matt Alexanderd9c56562020-05-21 10:49:17 +00001179function cgrep()
1180{
Mike Frysinger5e479732015-09-22 18:13:48 -04001181 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1182 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001183}
1184
Matt Alexanderd9c56562020-05-21 10:49:17 +00001185function resgrep()
1186{
Christopher Ferris55257d22017-03-23 11:08:58 -07001187 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001188 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1189 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1190 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001191}
1192
Matt Alexanderd9c56562020-05-21 10:49:17 +00001193function mangrep()
1194{
Mike Frysinger5e479732015-09-22 18:13:48 -04001195 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1196 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001197}
1198
Matt Alexanderd9c56562020-05-21 10:49:17 +00001199function owngrep()
1200{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001201 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1202 -exec grep --color -n "$@" {} +
1203}
1204
Matt Alexanderd9c56562020-05-21 10:49:17 +00001205function sepgrep()
1206{
Mike Frysinger5e479732015-09-22 18:13:48 -04001207 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1208 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001209}
1210
Matt Alexanderd9c56562020-05-21 10:49:17 +00001211function rcgrep()
1212{
Mike Frysinger5e479732015-09-22 18:13:48 -04001213 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1214 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001215}
1216
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001217case `uname -s` in
1218 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001219 function mgrep()
1220 {
Orion Hodson831472d2019-10-25 11:35:15 +01001221 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001222 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001223 }
1224
Matt Alexanderd9c56562020-05-21 10:49:17 +00001225 function treegrep()
1226 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001227 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001228 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001229 }
1230
1231 ;;
1232 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001233 function mgrep()
1234 {
Orion Hodson831472d2019-10-25 11:35:15 +01001235 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001236 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001237 }
1238
Matt Alexanderd9c56562020-05-21 10:49:17 +00001239 function treegrep()
1240 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001241 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001242 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001243 }
1244
1245 ;;
1246esac
1247
Matt Alexanderd9c56562020-05-21 10:49:17 +00001248function getprebuilt
1249{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001250 get_abs_build_var ANDROID_PREBUILTS
1251}
1252
Matt Alexanderd9c56562020-05-21 10:49:17 +00001253function tracedmdump()
1254{
Christopher Ferris55257d22017-03-23 11:08:58 -07001255 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001256 if [ ! "$T" ]; then
1257 echo "Couldn't locate the top of the tree. Try setting TOP."
1258 return
1259 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001260 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001261 local arch=$(gettargetarch)
1262 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001263
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001264 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001265 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001266 echo "usage: tracedmdump tracename"
1267 return
1268 fi
1269
Matt Alexanderd9c56562020-05-21 10:49:17 +00001270 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001271 echo "Error: cannot find kernel: '$KERNEL'"
1272 return
1273 fi
1274
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001275 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001276 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001277 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1278 fi
1279
1280 echo "post-processing traces..."
1281 rm -f $TRACE/qtrace.dexlist
1282 post_trace $TRACE
1283 if [ $? -ne 0 ]; then
1284 echo "***"
1285 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1286 echo "***"
1287 return
1288 fi
1289 echo "generating dexlist output..."
1290 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1291 echo "generating dmtrace data..."
1292 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1293 echo "generating html file..."
1294 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1295 echo "done, see $TRACE/dmtrace.html for details"
1296 echo "or run:"
1297 echo " traceview $TRACE/dmtrace"
1298}
1299
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001300# communicate with a running device or emulator, set up necessary state,
1301# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001302function runhat()
1303{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001304 # process standard adb options
1305 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001306 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001307 adbTarget=$1
1308 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001309 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001310 adbTarget="$1 $2"
1311 shift 2
1312 fi
1313 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001314 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001315
1316 # runhat options
1317 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001318
Matt Alexanderd9c56562020-05-21 10:49:17 +00001319 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001320 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001321 return
1322 fi
1323
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001324 # confirm hat is available
1325 if [ -z $(which hat) ]; then
1326 echo "hat is not available in this configuration."
1327 return
1328 fi
1329
Andy McFaddenb6289852010-07-12 08:00:19 -07001330 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001331 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001332 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001333 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001334 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001335 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001336 echo -n "> "
1337 read
1338
The Android Open Source Project88b60792009-03-03 19:28:42 -08001339 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001340
The Android Open Source Project88b60792009-03-03 19:28:42 -08001341 echo "Retrieving file $devFile..."
1342 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001343
The Android Open Source Project88b60792009-03-03 19:28:42 -08001344 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001345
The Android Open Source Project88b60792009-03-03 19:28:42 -08001346 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001347 echo "View the output by pointing your browser at http://localhost:7000/"
1348 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001349 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001350}
1351
Matt Alexanderd9c56562020-05-21 10:49:17 +00001352function getbugreports()
1353{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001354 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001355
1356 if [ ! "$reports" ]; then
1357 echo "Could not locate any bugreports."
1358 return
1359 fi
1360
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001361 local report
1362 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001363 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001364 echo "/sdcard/bugreports/${report}"
1365 adb pull /sdcard/bugreports/${report} ${report}
1366 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001367 done
1368}
1369
Matt Alexanderd9c56562020-05-21 10:49:17 +00001370function getsdcardpath()
1371{
Victoria Lease1b296b42012-08-21 15:44:06 -07001372 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1373}
1374
Matt Alexanderd9c56562020-05-21 10:49:17 +00001375function getscreenshotpath()
1376{
Victoria Lease1b296b42012-08-21 15:44:06 -07001377 echo "$(getsdcardpath)/Pictures/Screenshots"
1378}
1379
Matt Alexanderd9c56562020-05-21 10:49:17 +00001380function getlastscreenshot()
1381{
Victoria Lease1b296b42012-08-21 15:44:06 -07001382 local screenshot_path=$(getscreenshotpath)
1383 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001384 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001385 echo "No screenshots found."
1386 return
1387 fi
1388 echo "${screenshot}"
1389 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1390}
1391
Matt Alexanderd9c56562020-05-21 10:49:17 +00001392function startviewserver()
1393{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001394 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001395 if [ $# -gt 0 ]; then
1396 port=$1
1397 fi
1398 adb shell service call window 1 i32 $port
1399}
1400
Matt Alexanderd9c56562020-05-21 10:49:17 +00001401function stopviewserver()
1402{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001403 adb shell service call window 2
1404}
1405
Matt Alexanderd9c56562020-05-21 10:49:17 +00001406function isviewserverstarted()
1407{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001408 adb shell service call window 3
1409}
1410
Matt Alexanderd9c56562020-05-21 10:49:17 +00001411function key_home()
1412{
Romain Guyb84049a2010-10-04 16:56:11 -07001413 adb shell input keyevent 3
1414}
1415
Matt Alexanderd9c56562020-05-21 10:49:17 +00001416function key_back()
1417{
Romain Guyb84049a2010-10-04 16:56:11 -07001418 adb shell input keyevent 4
1419}
1420
Matt Alexanderd9c56562020-05-21 10:49:17 +00001421function key_menu()
1422{
Romain Guyb84049a2010-10-04 16:56:11 -07001423 adb shell input keyevent 82
1424}
1425
Matt Alexanderd9c56562020-05-21 10:49:17 +00001426function smoketest()
1427{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001428 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1429 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1430 return
1431 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001432 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001433 if [ ! "$T" ]; then
1434 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1435 return
1436 fi
1437
Ying Wang9cd17642012-12-13 10:52:07 -08001438 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001439 adb uninstall com.android.smoketest > /dev/null &&
1440 adb uninstall com.android.smoketest.tests > /dev/null &&
1441 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1442 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1443 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1444}
1445
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001446# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001447function runtest()
1448{
Christopher Ferris55257d22017-03-23 11:08:58 -07001449 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001450 if [ ! "$T" ]; then
1451 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1452 return
1453 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001454 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001455}
1456
The Android Open Source Project88b60792009-03-03 19:28:42 -08001457function godir () {
1458 if [[ -z "$1" ]]; then
1459 echo "Usage: godir <regex>"
1460 return
1461 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001462 local T=$(gettop)
1463 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001464 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001465 mkdir -p $OUT_DIR
1466 FILELIST=$OUT_DIR/filelist
1467 else
1468 FILELIST=$T/filelist
1469 fi
1470 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001471 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001472 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001473 echo " Done"
1474 echo ""
1475 fi
1476 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001477 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001478 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001479 echo "Not found"
1480 return
1481 fi
1482 local pathname
1483 local choice
1484 if [[ ${#lines[@]} > 1 ]]; then
1485 while [[ -z "$pathname" ]]; do
1486 local index=1
1487 local line
1488 for line in ${lines[@]}; do
1489 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001490 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001491 done
1492 echo
1493 echo -n "Select one: "
1494 unset choice
1495 read choice
1496 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1497 echo "Invalid choice"
1498 continue
1499 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001500 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001501 done
1502 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001503 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001504 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001505 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001506}
1507
Steven Moreland62054a42018-12-06 10:11:40 -08001508# Update module-info.json in out.
1509function refreshmod() {
1510 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1511 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1512 return 1
1513 fi
1514
1515 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1516
1517 # for the output of the next command
1518 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1519
1520 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001521 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001522 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1523}
1524
Cole Faust3e192382021-10-25 13:29:15 -07001525# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001526function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001527 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001528 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1529 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1530 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001531 return 1
1532 fi
1533
1534 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001535 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001536 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001537 fi
1538 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001539 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001540}
1541
1542# List all modules for the current device, as cached in module-info.json. If any build change is
1543# made and it should be reflected in the output, you should run 'refreshmod' first.
1544function allmod() {
1545 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001546
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001547 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001548}
1549
Joe Onorato2c1aa472021-02-25 16:42:39 -08001550# Get the path of a specific module in the android tree, as cached in module-info.json.
1551# If any build change is made, and it should be reflected in the output, you should run
1552# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001553function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001554 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001555 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001556 return 1
1557 fi
1558
Cole Faust24c36db2021-01-23 02:39:37 +00001559 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001560
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001561 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001562module = '$1'
1563module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1564if module not in module_info:
1565 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001566print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001567
1568 if [ -z "$relpath" ]; then
1569 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1570 return 1
1571 else
Rett Berg78d1c932019-01-24 14:34:23 -08001572 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001573 fi
1574}
1575
Joe Onorato2c1aa472021-02-25 16:42:39 -08001576# Get the path of a specific module in the android tree, as cached in module-info.json.
1577# If any build change is made, and it should be reflected in the output, you should run
1578# 'refreshmod' first. Note: This is the inverse of pathmod.
1579function dirmods() {
1580 if [[ $# -ne 1 ]]; then
1581 echo "usage: dirmods <path>" >&2
1582 return 1
1583 fi
1584
1585 verifymodinfo || return 1
1586
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001587 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001588dir = '$1'
1589while dir.endswith('/'):
1590 dir = dir[:-1]
1591prefix = dir + '/'
1592module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1593results = set()
1594for m in module_info.values():
1595 for path in m.get(u'path', []):
1596 if path == dir or path.startswith(prefix):
1597 name = m.get(u'module_name')
1598 if name:
1599 results.add(name)
1600for name in sorted(results):
1601 print(name)
1602"
1603}
1604
1605
Rett Berg78d1c932019-01-24 14:34:23 -08001606# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1607# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1608function gomod() {
1609 if [[ $# -ne 1 ]]; then
1610 echo "usage: gomod <module>" >&2
1611 return 1
1612 fi
1613
1614 local path="$(pathmod $@)"
1615 if [ -z "$path" ]; then
1616 return 1
1617 fi
1618 cd $path
1619}
1620
Cole Faust24c36db2021-01-23 02:39:37 +00001621# Gets the list of a module's installed outputs, as cached in module-info.json.
1622# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1623function outmod() {
1624 if [[ $# -ne 1 ]]; then
1625 echo "usage: outmod <module>" >&2
1626 return 1
1627 fi
1628
1629 verifymodinfo || return 1
1630
1631 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001632 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001633module = '$1'
1634module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1635if module not in module_info:
1636 exit(1)
1637for output in module_info[module]['installed']:
1638 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1639
1640 if [ $? -ne 0 ]; then
1641 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1642 return 1
1643 elif [ ! -z "$relpath" ]; then
1644 echo "$relpath"
1645 fi
1646}
1647
1648# adb install a module's apk, as cached in module-info.json. If any build change
1649# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1650# Usage: installmod [adb install arguments] <module>
1651# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1652function installmod() {
1653 if [[ $# -eq 0 ]]; then
1654 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001655 echo "" >&2
1656 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1657 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1658 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001659 return 1
1660 fi
1661
1662 local _path
1663 _path=$(outmod ${@:$#:1})
1664 if [ $? -ne 0 ]; then
1665 return 1
1666 fi
1667
1668 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1669 if [ -z "$_path" ]; then
1670 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1671 return 1
1672 fi
Cole Faust3e192382021-10-25 13:29:15 -07001673 local serial_device=""
1674 if [[ "$1" == "-s" ]]; then
1675 if [[ $# -le 2 ]]; then
1676 echo "-s requires an argument" >&2
1677 return 1
1678 fi
1679 serial_device="-s $2"
1680 shift 2
1681 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001682 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001683 echo adb $serial_device install ${@:1:$length} $_path
1684 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001685}
1686
dimitry73b84812018-12-11 18:06:00 +01001687function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001688 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001689 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001690}
1691
Alex Rayf0d08eb2013-03-08 15:15:06 -08001692# Print colored exit condition
1693function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001694 "$@"
1695 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001696 if [ $retval -ne 0 ]
1697 then
Jacky Cao89483b82015-05-15 22:12:53 +08001698 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001699 else
Jacky Cao89483b82015-05-15 22:12:53 +08001700 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001701 fi
1702 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001703}
1704
Matt Alexanderd9c56562020-05-21 10:49:17 +00001705function get_make_command()
1706{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001707 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1708 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001709 # Always use the real make if -C is passed in
1710 for arg in "$@"; do
1711 if [[ $arg == -C* ]]; then
1712 echo command make
1713 return
1714 fi
1715 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001716 echo build/soong/soong_ui.bash --make-mode
1717 else
1718 echo command make
1719 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001720}
1721
Matt Alexanderd9c56562020-05-21 10:49:17 +00001722function _wrap_build()
1723{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001724 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1725 "$@"
1726 return $?
1727 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001728 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001729 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001730 local ret=$?
1731 local end_time=$(date +"%s")
1732 local tdiff=$(($end_time-$start_time))
1733 local hours=$(($tdiff / 3600 ))
1734 local mins=$((($tdiff % 3600) / 60))
1735 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001736 local ncolors=$(tput colors 2>/dev/null)
1737 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001738 color_failed=$'\E'"[0;31m"
1739 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001740 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001741 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001742 else
1743 color_failed=""
1744 color_success=""
1745 color_reset=""
1746 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001747
1748 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1749 echo
1750 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1751 fi
1752
Ed Heylcc6be0a2014-06-18 14:55:58 -07001753 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001754 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001755 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001756 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001757 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001758 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001759 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001760 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001761 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001762 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001763 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001764 printf "(%s seconds)" $secs
1765 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001766 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001767 echo
1768 return $ret
1769}
1770
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001771function _trigger_build()
1772(
1773 local -r bc="$1"; shift
1774 if T="$(gettop)"; then
1775 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1776 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001777 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1778 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001779 fi
1780)
1781
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001782# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001783function b()
1784(
1785 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Sam Delmerico9d67a902022-04-11 12:25:18 +00001786 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001787 # Then, run Bazel using the synthetic workspace as the --package_path.
Sam Delmerico9d67a902022-04-11 12:25:18 +00001788 if [[ -z "$@" ]]; then
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001789 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001790 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001791 else
1792 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Sam Delmerico9d67a902022-04-11 12:25:18 +00001793 bazel "$@" --config=bp2build
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001794 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001795)
1796
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001797function m()
1798(
1799 _trigger_build "all-modules" "$@"
1800)
1801
1802function mm()
1803(
1804 _trigger_build "modules-in-a-dir-no-deps" "$@"
1805)
1806
1807function mmm()
1808(
1809 _trigger_build "modules-in-dirs-no-deps" "$@"
1810)
1811
1812function mma()
1813(
1814 _trigger_build "modules-in-a-dir" "$@"
1815)
1816
1817function mmma()
1818(
1819 _trigger_build "modules-in-dirs" "$@"
1820)
1821
Matt Alexanderd9c56562020-05-21 10:49:17 +00001822function make()
1823{
Dan Willemsene9842242017-07-28 13:00:13 -07001824 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001825}
1826
Matt Alexanderd9c56562020-05-21 10:49:17 +00001827function provision()
1828{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001829 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1830 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1831 return 1
1832 fi
1833 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1834 echo "There is no provisioning script for the device." >&2
1835 return 1
1836 fi
1837
1838 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001839 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001840 shift 1
1841 else
1842 echo "This action will reflash your device."
1843 echo ""
1844 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1845 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001846 echo -n "Are you sure you want to do this (yes/no)? "
1847 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001848 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001849 echo "Not taking any action. Exiting." >&2
1850 return 1
1851 fi
1852 fi
1853 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1854}
1855
Jim Tanga881a252018-06-19 16:34:41 +08001856# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001857function enable_zsh_completion() {
1858 # Don't override user's options if bash-style completion is already enabled.
1859 if ! declare -f complete >/dev/null; then
1860 autoload -U compinit && compinit
1861 autoload -U bashcompinit && bashcompinit
1862 fi
Jim Tanga881a252018-06-19 16:34:41 +08001863}
1864
1865function validate_current_shell() {
1866 local current_sh="$(ps -o command -p $$)"
1867 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001868 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001869 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001870 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001871 *zsh*)
1872 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001873 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001874 *)
Jim Tanga881a252018-06-19 16:34:41 +08001875 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001876 ;;
1877 esac
Jim Tanga881a252018-06-19 16:34:41 +08001878}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001879
1880# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001881# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1882# load those.
1883#
1884# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001885function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001886 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001887 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001888 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001889 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001890 if [ -n "$allowed" ]; then
1891 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1892 echo " $allowed"
1893 echo " $f"
1894 return
1895 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001896 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001897 done
1898
1899 allowed_files=
1900 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001901 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001902 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001903 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001904
1905 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001906 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001907 else
1908 echo "ignoring $f, not in $allowed"
1909 fi
Jim Tanga881a252018-06-19 16:34:41 +08001910 done
1911 done
1912}
Kenny Root52aa81c2011-07-15 11:07:06 -07001913
Dan Albertbab814f2020-08-26 15:34:53 -07001914function showcommands() {
1915 local T=$(gettop)
1916 if [[ -z "$TARGET_PRODUCT" ]]; then
1917 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1918 return
1919 fi
1920 case $(uname -s) in
1921 Darwin)
1922 PREBUILT_NAME=darwin-x86
1923 ;;
1924 Linux)
1925 PREBUILT_NAME=linux-x86
1926 ;;
1927 *)
1928 >&2 echo Unknown host $(uname -s)
1929 return
1930 ;;
1931 esac
1932 if [[ -z "$OUT_DIR" ]]; then
1933 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1934 OUT_DIR=out
1935 else
1936 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1937 fi
1938 fi
1939 if [[ "$1" == "--regenerate" ]]; then
1940 shift 1
1941 NINJA_ARGS="-t commands $@" m
1942 else
1943 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1944 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1945 -t commands "$@")
1946 fi
1947}
1948
Jim Tanga881a252018-06-19 16:34:41 +08001949validate_current_shell
1950source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001951addcompletions